//! Main Galaxion class. Gameloop and Events are managed here.
//! Some minor brain features are controlled here such as Brain movement, firing and layout.
//! collision checks between brains and ship is also listed here.
//! The final game status such as Win or Lose is also managed via galaxion.cpp

#include <iostream>
#include "Galaxion.h"
#include "SplashScreen.h"
#include "MainMenu.h"
#include "VisibleGameObject.h"
#include "SpaceShip.h"
#include "Projectile.h"
#include "Brain.h"
#include "PowerUp.h"
#include "StopWatch.h"
#include "Score.h"


using namespace sf;

//Put in galaxion class
 int x = 355;
 int y = 600;
 int a = x;
 int b = y;
 int c = 300;
 int d  = 5;
 int e = 180;
 int f = 40;
 int g = e;
 int e1 = e;
 int e2 = e;
 int e3 = e;
 int e4 = e;
 int e5 = e;
 int h = f;
 int m,n;
 int t,u;
 float uu,tt;
 int z = 0;

 int cadets = 7;
 int r[7] = {0};
 float ab,bb,cb,db,eb,fb,gb,hb;
 float _elapsedTimeSinceCreated = 2001;
 float _elapsedTimeSinceCreatedBrain = 0;
 float _elapsedTimeSinceCreatedBrain11 = 0 ;
 float _elapsedTimeSinceCreatedBrain33 = 0 ;
 float _elapsedTimeSinceCreatedBrain34 = 0 ;
 float _elapsedTimeSinceCreatedBrain35 = 0 ;
 float _timeCreated = 0;
 float _braintTimeCreated = 0;
 float _brain11tTimeCreated = 0;
 float _brain33tTimeCreated = 0;
 float _brain34tTimeCreated = 0;
 float _brain35tTimeCreated = 0;

 float bulletTimeCreated[35] = {};
 //float elapsedTimeSinceCreatedBrainProjectile[35] = {};

 float leftBoundry,rightBoundry,topBoundry,bottomBoundry;
 bool dive = false;
 bool collision = false;
 bool hit = false;
 bool rev = false;
 bool power = true;
 bool offScreen = false;


Galaxion::GameState Galaxion::_gameState = Uninitialized;
RenderWindow Galaxion::_mainWindow;
SpaceShip Galaxion::_player1; //global
Projectile Galaxion::_projectile;//global
BrainProjectile Galaxion::_brain_projectile;//global
Brain Galaxion::_brain;//global
Score Galaxion::_score;//global
Galaxion _galac;


Brain* _brain1 = new Brain[cadets] ;
Brain* _brain2 = new Brain[cadets] ;
Brain* _brain3 = new Brain[cadets] ;
Brain* _brain4 = new Brain[cadets] ;
Brain* _brain5 = new Brain[cadets] ;


float time_1 = std::clock();

void Galaxion::Run(void) //Dont think we need void
{
    if(_gameState != Uninitialized) //GameState is undefined
    return;

    _mainWindow.create(VideoMode(800,800,32),"GALAXION"); //Openning game and setting size and type of screen
    _gameState= Galaxion::ShowingSplash; //Show main menu using member function
    _player1.load("SpaceShip3.png"); //Loading image of player 1
    _player1.setPosition(x,y); //Starting position of player 1

    while(!IsExiting()) //Continue game till game is excited
    {
        GameLoop();
        _mainWindow.display();
    }

    _mainWindow.close(); //Closing game when game is excited
}

bool Galaxion::IsExiting() //what is the defualt setting of gameState? Uninitialised
{
    if(_gameState == Galaxion::Exiting)
    return true;
    else
    return false;
}

void Galaxion::GameLoop()
{
    _mainWindow.display();
     Event currentEvent; //Event of SFML library
    _mainWindow.pollEvent(currentEvent);//) //Listen out for event

    switch(_gameState)
    {
        case Galaxion::Playing:
                {
                  playing(currentEvent);
                  _mainWindow.display();
                  break;
                }
        case Galaxion::ShowingMenu:
                {
                  ShowMenu();
                  break;
                }
        case Galaxion::ShowingSplash:
               {
                 ShowSplashScreen();
                 break;
               }
        case Galaxion::Paused:
               {
                 break;
               }
        case Galaxion::Exiting:
               {
                 break;
               }
        case Galaxion::Uninitialized:
               {
                 break;
               }
        }
}
void Galaxion::playing(Event currentEvent) //Startup screen
 {
                 PowerUp _power;
                 string powerd;
                _mainWindow.clear(Color(0,0,0));
                _player1.draw(_mainWindow);
                 BrainArmy();
                 PowerUp::Placement(z,power,ab,bb,cb,db);
                _player1.torpedo = _power.getTorpedo();
                _player1.shield =_power.getShield();
                _player1.virus =_power.getVirus();
                _player1.wrapAround =_power.getWrapAround();
                _score.Score::DisplayScore(_score.GameScore);
                 endGameCheck();
                 checkEvents(currentEvent);
                _elapsedTimeSinceCreated = _projectile.Timer(_timeCreated);
                _elapsedTimeSinceCreatedBrain = _brain.Timer(_braintTimeCreated);
                _projectile.update(_elapsedTimeSinceCreated,a,b,hit);

                 if(_player1.virus == false)
                 {
                 if(hit == false)
                 _projectile.draw(_mainWindow);
                 }else{
                 _projectile.draw(_mainWindow);
                 }
                 _projectile.setBoundry(leftBoundry,rightBoundry,topBoundry,bottomBoundry,_player1.torpedo);
                  power = _player1.collisionCheck(ab,bb,cb,db,false,power,_score.GameScore);
                 if(power==false)
                   PowerUp::Select(powerd);

                 _score.PowerUp(powerd);
                if(_player1.shield && _galac.time_5 <1000)
                  {
                    _galac.time_5++;
                    PowerUp::Shield(x,y);
                  }else _player1.shield = false;
 }
void Galaxion::checkEvents(Event currentEvent)
{
                    if(currentEvent.type == Event::Closed || currentEvent.key.code== Keyboard::Escape)
                    {
                        _gameState = Galaxion::Exiting;
                    }
                    if(currentEvent.key.code== Keyboard::Left)
                    {
                        if(_player1.wrapAround)//power up activated
                        {
                          Galaxion::Direction dir = LEFT;
                          PowerUp::WrapAround(dir,x);
                        }else{
                        if(x>0)
                           x=x-20;
                        }
                        _player1.setPosition(x,y);
                    }
                    if(currentEvent.key.code== Keyboard::Right)
                    {
                        if(_player1.wrapAround)//powerup activated
                            {
                            Galaxion::Direction dir = RIGHT;
                            PowerUp::WrapAround(dir,x);
                            }else{
                            if(x<700)
                               x=x+20;
                            }
                            _player1.setPosition(x,y);
                    }
                    if(currentEvent.key.code== Keyboard::Up)
                    {
                        if(y>0)
                           y=y-20;
                        _player1.setPosition(x,y);
                    }
                    if(currentEvent.key.code== Keyboard::Down)
                    {
                        if(y<600)
                           y=y+20;
                        _player1.setPosition(x,y);
                    }
                    if(currentEvent.key.code== Keyboard::Space)
                    {
                        if (_elapsedTimeSinceCreated > 1500 )
                         {
                             if (_player1.virus)
                             {
                           _projectile.load("virus2.png");
                             a = x +15;
                             b = y-50;

                             }else{
                                  if (_player1.torpedo)
                                  {
                                  _projectile.load("bolt.png");
                                 a = x-40;
                                 b = y-100;
                                  }else
                                  {
                                 _projectile.load("Projectile3.png");
                                 a = x+30;
                                 b = y-40;
                                  }
                             }
                         _projectile.draw(_mainWindow);
                         _mainWindow.display();
                         _projectile.setPosition(a,b);
                         _timeCreated = _projectile.timeCreated();
                         hit = false;
                         _player1.torpedo =false;//only allows 1 shot of each
                         _player1.gunSlinger =false;
                         _player1.virus =false;
                        }

                    }
                    if(currentEvent.key.code== Keyboard::LControl)
                    {

                    }
}
void Galaxion::ShowSplashScreen() //Startup screen
 {
   SplashScreen splashScreen;
   splashScreen.Show(_mainWindow);
   _gameState = Galaxion::ShowingMenu;
 }

 void Galaxion::ShowMenu()
{
   MainMenu mainMenu;
   MainMenu::MenuResult result = mainMenu.Show(_mainWindow);
   switch(result)
   {
   case MainMenu::Exit:
       _gameState = Galaxion::Exiting;
       break;
   case MainMenu::Play:
       _gameState = Galaxion::Playing;
       break;
   case MainMenu::Nothing:
       break;
   }
 }

string Galaxion::getState()
{
    switch(_gameState)
    {
        case Galaxion::Playing:
            {
                return "Playing";
            }
        case Galaxion::ShowingMenu:
            {
                return"ShowingMenu";
            }
        case Galaxion::ShowingSplash:
            {
                return "ShowingSplash";
            }
        case Galaxion::Paused:
           {
                return "Paused";
           }
        case Galaxion::Exiting:
           {
                return "Exiting";
           }
        case Galaxion::Uninitialized:
           {
                return "Uninitialized";
           }
        }
}

void Galaxion::setState(GameState state)
{
    _gameState = state;
}

void Galaxion::BrainArmy()
{

    for(int i=0;i<7;i++)
        {
                if(i == 0)
                _brain1[i].load("brain_freeze3.png");
                else
                _brain1[i].load("brain.png");

                        if(_galac.hit1[i] == true)
                        {
                        _brain1[i].setPosition(900,900);

                        }else
                        {
                        _brain1[i].setPosition(e+60*i,f);
                       // BrainMovement(_brain1);
                        }

                    _elapsedTimeSinceCreatedBrain11 = _brain1[0].Timer(_brain11tTimeCreated);

                    float temp_x,temp_y;
                    _brain1[0].getPosition(temp_x,temp_y);
                    if(temp_y!=900)
                    _brain1[0].arc(_elapsedTimeSinceCreatedBrain11,g,h,e,f);

                     _galac.alive1[i] = _brain1[i].collisionCheck(leftBoundry, rightBoundry,topBoundry, bottomBoundry, &_galac.hit1[7], &_galac.alive1[7],_score.GameScore);
                         if(_galac.alive1[i] == false)
                         {
                         _brain1[i].setPosition(900,900);

                         _galac.hit1[i] = true;
                         hit = true;
                         }
                    if(_galac.alive1[i] == true && _galac.hit1[i] == false)
                    {
                    _brain1[i].draw(_mainWindow);
                    }
        }


        float  elapsedTimeSinceCreatedBrainProjectile[7]={3000,3000,3000,3000,3000,3000,3000};//initial time
        BrainFire(_brain1,elapsedTimeSinceCreatedBrainProjectile,bulletTimeCreated);

                for(int i=0;i<7;i++)
                {
                _brain2[i].load("brain.png");
                if(_galac.hit2[i] == true)
                {
                _brain2[i].setPosition(900,900);

                }else{
                _brain2[i].setPosition(e1+60+60*i,f+60);
                BrainMovement(_brain2);
                }

                 _galac.alive2[i] = _brain2[i].collisionCheck(leftBoundry, rightBoundry,topBoundry, bottomBoundry, &_galac.hit2[7], &_galac.alive2[7],_score.GameScore);
                 if(_galac.alive2[i] == false)
                 {
                 _galac.hit2[i] = true;
                 hit = true;
                 }
                if(_galac.alive2[i] == true && _galac.hit2[i] == false)
                _brain2[i].draw(_mainWindow);
                }
                for(int i=0;i<7;i++)
                {
                if(i == 4)
                _brain3[i].load("brain_freeze3.png");
                else
                _brain3[i].load("brain.png");
                if(_galac.hit3[i] == true)
                {
                _brain3[i].setPosition(900,900);

                }else{
                if(i!=4)
                _brain3[i].setPosition(e2+60*i,f+120);

                }
                    _brain3[4].getPosition(tt,uu);
                    if(tt == 0)
                    tt = 180+60*4;
                    t=tt;
                    u= uu;
                    _elapsedTimeSinceCreatedBrain34 = _brain3[4].Timer(_brain34tTimeCreated);
                    _brain3[4].dive(_elapsedTimeSinceCreatedBrain34,t,u,tt,f+120);

                _galac.alive3[i] = _brain3[i].collisionCheck(leftBoundry, rightBoundry,topBoundry, bottomBoundry, &_galac.hit3[7], &_galac.alive3[7],_score.GameScore);
                 if(_galac.alive3[i] == false)
                 {
                 _galac.hit3[i] = true;
                 hit = true;
                 }
                if(_galac.alive3[i] == true && _galac.hit3[i] == false)
                _brain3[i].draw(_mainWindow);
                 BrainFire(_brain3,elapsedTimeSinceCreatedBrainProjectile,bulletTimeCreated);
                }
                for(int i=0;i<7;i++)
                {
                if(i == 6)
                _brain4[i].load("brain_fire3.png");
                else
                _brain4[i].load("brain.png");
                if(_galac.hit4[i] == true)
                {
                _brain4[i].setPosition(900,900);

                }else{
                _brain4[i].setPosition(e3+60+60*i,f+180);
                BrainMovement(_brain4);

                }
                 _galac.alive4[i] = _brain4[i].collisionCheck(leftBoundry, rightBoundry,topBoundry, bottomBoundry, &_galac.hit4[7], &_galac.alive4[7],_score.GameScore);
                 if(_galac.alive4[i] == false)
                 {
                 _galac.hit4[i] = true;
                 hit = true;
                 }
                    if(_galac.alive4[i] == true && _galac.hit4[i] == false)
                    {
                    _brain4[i].draw(_mainWindow);
                    }else{}
                }
                for(int i=0;i<7;i++)
                {
                _brain5[i].load("brain.png");
                if(_galac.hit5[i] == true)
                {
                _brain5[i].setPosition(900,900);

                }else{
                _brain5[i].setPosition(e4+60*i,f+240);

                }
                 _galac.alive5[i] = _brain5[i].collisionCheck(leftBoundry, rightBoundry,topBoundry, bottomBoundry, &_galac.hit5[7], &_galac.alive5[7],_score.GameScore);
                 if(_galac.alive5[i] == false)
                 {
                 _galac.hit5[i] = true;
                 hit = true;
                 }
                if(_galac.alive5[i] == true && _galac.hit5[i] == false)
                _brain5[i].draw(_mainWindow);

                }
                Crash(_brain1);
                Crash(_brain2);
                Crash(_brain3);
                Crash(_brain4);
                Crash(_brain5);
}
///this function can be used on all brain arrays (each array represents a row in the formation
///I have not included it in each array as too many bullets firing cause gameplay to be too difficult.
void Galaxion::BrainFire(Brain brain_[],float elapsedTimeSinceCreatedBrainProjectile_[],float bulletTimeCreated_[])
{
    int r[7] = {};
    float o,p;

    for(int i=0;i<7; i = i +2)//every SECOND brain shoots else it gets too difficult with too many bullets
    {

        if (_galac.pos[i] == false)
        {
            brain_[i].getPosition(o,p);
        }

                r[i] = brain_[i].Shoot();//randomising the shooting
                 if(r[i]>99  && elapsedTimeSinceCreatedBrainProjectile_[i]>15000)//decrease 99 to make more frequent firing.
                    //decrease 10000 to decrease time between shots
                 {
                     bulletTimeCreated_[i] = _brain_projectile.timeCreated();
                    _brain_projectile.load("brain_Projectile1.png");
                 }
                 elapsedTimeSinceCreatedBrainProjectile_[i] = _brain_projectile.Timer(bulletTimeCreated[i]);
                _brain_projectile.brainUpdate(elapsedTimeSinceCreatedBrainProjectile_[i],o,p,false);
                _brain_projectile.draw(_mainWindow);

                _brain_projectile.setBoundry(eb,fb,gb,hb,_player1.torpedo);
                if(_player1.shield == false)
                {
                 _galac.life = _player1.collisionCheck(eb,fb,gb,hb,false,_galac.life,_score.GameScore);

                 if(_galac.life==false)
                 {
                  _player1.load("explode1.png");
                  _player1.setPosition(x-20,y);
                  _score.Score::GameOver();
                  //_gameState = Galaxion::Paused;
                 }
                }
                 //if(life==false)
                   // _player1.setPosition(900,900);
   }
}
///this function can be used on all brain arrays (each array represents a row in the formation
///I have only used it for two rows as too many things moving on the screen makes me dizzy.
void Galaxion::BrainMovement(Brain brain_[])
{

    float a,b;
    bool reset = true;
    for(int i = 0 ;i<7; i++)
    {
        brain_[i].getPosition(a,b);
        if(_galac.time_2 < 3000)
        brain_[i].setPosition(a+(_galac.time_2/50),b);

             if(_galac.time_2 > 3000)
                   {
                    brain_[i].getPosition(a,b);
                    brain_[i].setPosition(a-(_galac.time_2/50),b);
                   }
                    if(_galac.time_2 > 6000)
                    {
                        _galac.time_2 = 0;
                    }
    }
       _galac.time_2++;
}

void Galaxion::Crash(Brain brain_[])
{
    float boundry_x1,boundry_x2,boundry_y1,boundry_y2;
    for(int i =0 ; i<7;i++)
    {
                 brain_[i].setBoundry(boundry_x1,boundry_x2,boundry_y1,boundry_y2,false);
                 if(_player1.shield == false)
                 {
                 _galac.life = _player1.collisionCheck(boundry_x1,boundry_x2,boundry_y1,boundry_y2,false,_galac.life,_score.GameScore);

                     if(_galac.life==false)
                     {
                      _player1.load("explode1.png");
                      _player1.setPosition(x-20,y);
                       brain_[i].setPosition(900,900);
                      _score.Score::GameOver();
                      //_gameState = Galaxion::Paused;
                      _galac.gameOver = true;
                     }
                 }
    }
}

 void Galaxion::endGameCheck()
{
    _galac.killCount =0;

   for(int i=0;i<7;i++)
    {
         if( _galac.hit1[i])
        _galac.killCount++;
         if( _galac.hit2[i])
        _galac.killCount++;
         if( _galac.hit3[i])
        _galac.killCount++;
         if( _galac.hit4[i])
        _galac.killCount++;
         if( _galac.hit5[i])
        _galac.killCount++;
         if(_galac.killCount>34)
         {
        _score.Score::win();
        _galac.gameWin = true;
         }
    }
}

bool Galaxion::getWin()
{
    return _galac.gameWin;
}

bool Galaxion::getGameOver()
{
    return _galac.gameOver;
}

int Galaxion::getKillCount()
{
    return _galac.killCount;
}
