//!adds advanced timing for processes such as moving projectiles.

#include "StopWatch.h"
#include <iostream>
#include <ctime>
#include <cmath>

using namespace std;

// returns the amount of time in seconds that has passed since the process (i.e. your program) started executing
double Stopwatch::getProcessTime()
{
	clock_t time = clock();
	return static_cast<double>(time)/CLOCKS_PER_SEC;
}

Stopwatch::Stopwatch(){
	iMilliSecond = 0;
	iSecond = 0;
	iMinute = 0;
	iHour = 0;
	dTempTime = 0.0;
	dTotalTime = 0.0;
	status = STOPPED;
}

void Stopwatch::display(){
	calcTime();
	cout << iHour << ":" << iMinute << ":" << iSecond << ":" << iMilliSecond << endl;
}

void Stopwatch::modTime(double totaltime){
	iSecond = floor(totaltime);
	iMilliSecond = floor(100*(totaltime-iSecond));

	iMinute = (iSecond % (60 * 60))/60;
	iHour = iSecond/(60 * 60);
	iSecond = iSecond % 60;
}

void Stopwatch::start(){
	status = STARTED;
	dTempTime = getProcessTime();
}

void Stopwatch::stop(){
	status = STOPPED;
}

void Stopwatch::reset(){
	status = RESET;
}

void Stopwatch::calcTime(){
	switch (status) {
		case STARTED:
				dTotalTime = getProcessTime() - dTempTime;
			break;

		case RESET:
				dTempTime = dTotalTime;
				dTotalTime = 0.0;
			break;
		default:
			break;
	}

	modTime(dTotalTime);
}
