//!VisibleGameObject class controls all the manipulations of the objects on the screen.
//! position setting, boundry setting, projectile movement, brains movement (arc,dive).

#include "VisibleGameObject.h"
#include "Galaxion.h"
#include <cmath>
#include "math.h"
#define PI 3.14159265
#include <iostream>
#include "SpaceShip.h"
#include "Score.h"


VisibleGameObject::VisibleGameObject()
{
  _isLoaded = false;
}

VisibleGameObject::~VisibleGameObject()
{
}
float VisibleGameObject::timeCreated()
{
    _timeCreated = std::clock();
    return _timeCreated;
}

float VisibleGameObject::Timer(float _timeCreated)
{
   _elapsedTimeSinceCreated = std::clock() - _timeCreated;
return _elapsedTimeSinceCreated;
}

void VisibleGameObject::load(std::string filename)
{
  if(_texture.loadFromFile(filename) == false)
  {
    _filename = "";
    _isLoaded = false;
  }
  else
  {
    _filename = filename;
    _sprite.setTexture(_texture);
    _isLoaded = true;
  }
}

void VisibleGameObject::draw(sf::RenderWindow & renderWindow)
{
  if(_isLoaded)
  {
    renderWindow.draw(_sprite);

  }
}

void VisibleGameObject::setPosition(float x, float y)
{
  if(_isLoaded)
  {
    _sprite.setPosition(x,y);
  }
}

void VisibleGameObject::getPosition(float &x,float &y)
{
  if(_isLoaded)
  {
   x = _sprite.getPosition().x;
   y = _sprite.getPosition().y;
  }
}

void VisibleGameObject::startPosition(float x,float y)
{
     if(_isLoaded)
  {
    _sprite.setPosition(x,y-30);
  }
}

void VisibleGameObject::trajectory(float x,float y)
{
     if(_isLoaded)
  {
     while(y>0)
     {
         y = y - 2;
        _sprite.setPosition(x,y);
     }
  }
}

void VisibleGameObject::update(float _elapsedTimeSinceCreated, int a , int b, bool hit)
{
    if(_isLoaded == true)
    {

    if(Galaxion::_player1.virus == true)
    {
    b = b - _elapsedTimeSinceCreated/4;
    _sprite.setPosition(a,b);

    if(b < 0)
        _sprite.setPosition(900,900);

    }else if (hit == false)
           {
           b = b - _elapsedTimeSinceCreated/4;
           _sprite.setPosition(a,b);
           }
    }
}
void VisibleGameObject::setBoundry(float &leftBoundry,float &rightBoundry,float &topBoundry,float &bottomBoundry, bool torpedo)
{
     if(_isLoaded)
  {
      if(torpedo)
      {
      leftBoundry =_sprite.getPosition().x - 10;
      rightBoundry =_sprite.getPosition().x + 140;
      topBoundry =_sprite.getPosition().y - 20;
      bottomBoundry =_sprite.getPosition().y + 50;
      }else
      {
      leftBoundry =_sprite.getPosition().x - 30;
      rightBoundry =_sprite.getPosition().x + 30;
      topBoundry =_sprite.getPosition().y - 20;
      bottomBoundry =_sprite.getPosition().y + 20;
      }
  }
}

void VisibleGameObject::setShipBoundry(float &leftBoundry,float &rightBoundry,float &topBoundry,float &bottomBoundry, bool torpedo)
{
     if(_isLoaded)
  {
      leftBoundry =_sprite.getPosition().x - 40;
      rightBoundry =_sprite.getPosition().x + 40;
      topBoundry =_sprite.getPosition().y - 100;
      bottomBoundry =_sprite.getPosition().y;

  }
}

bool VisibleGameObject::collisionCheck(float leftBoundry,float rightBoundry, float topBoundry, float bottomBoundry,bool hit,bool alive,float &GameScore)
{
     if(_isLoaded)
  {
      if (_sprite.getPosition().x > leftBoundry && _sprite.getPosition().x < rightBoundry && _sprite.getPosition().y > topBoundry && _sprite.getPosition().y < bottomBoundry )
       {
        collision = true;
        hit = true;
        alive = destroy(collision,GameScore);
        if (hit == true && _sprite.getPosition().y!=900)
        GameScore = GameScore + 100;
       }
  }
return alive;
}

bool VisibleGameObject::destroy(bool collision,float &GameScore)
{
     if(collision)
     {
     return false;
     }
}

void VisibleGameObject::arc(float _elapsedTimeSinceCreated, int c , int &d, int e, int f)
{

    if(_elapsedTimeSinceCreated > 1)
        {
            if(c<400)
            c = sqrt(d)*exp(1/2)*sqrt(900-1.3*d);
            else c = 800 - d*exp(1/2);

            d = d + (_elapsedTimeSinceCreated)/20000;//10000 determines the time to wait before moving

            if(c < 0)
            {
              offScreen = true;
              d = 0;
            }
            else
            _sprite.setPosition(c,d);

            if(offScreen)
            {
                if(d<f)
                {
                _sprite.setPosition(e,d);
                d = d + 5;
                }else{
                _sprite.setPosition(e,f);

                }
                if(d=f)
                _sprite.setPosition(e,f);

            }

        }
}
void VisibleGameObject::dive(float _elapsedTimeSinceCreated, int c , int &d, int e, int f)
{
       if(diveoffScreen == false)
            {
            d =(_elapsedTimeSinceCreated/10);//;/10;//2000;//10000 determines the time to wait before moving
            _sprite.setPosition(c,d);
                if (d>800)
                {
                d = 2;
                _sprite.setPosition(c,d);
                diveoffScreen = true;
                }
            }else{
                    if(d<f)
                   {
                   d = (8000 -_elapsedTimeSinceCreated)/10;//2000;//10000 determines the time to wait before moving
                   d = -d;
                   _sprite.setPosition(e,d);
                   }
                }
}
