#ifndef VisibleGameObject_H
#define VisibleGameObject_H
#include <string>
#include "SFML/Window.hpp"
#include "SFML/Graphics.hpp"
#include "Score.h"

using namespace sf;

 class VisibleGameObject
 {
 public:
   VisibleGameObject();
   virtual ~VisibleGameObject();

   float _elapsedTimeSinceCreated;
   virtual void load(std::string filename);
   virtual void draw(RenderWindow & window);

   virtual void setPosition(float x, float y);
   virtual void getPosition(float &x, float &y);
   virtual void startPosition(float x, float y);
   virtual void trajectory(float x, float y);
   virtual void setBoundry(float &leftBoundry, float &rightBoundry, float &topBoundry ,float &bottomBoundry, bool torpedo);
   virtual void setShipBoundry(float &leftBoundry, float &rightBoundry, float &topBoundry ,float &bottomBoundry, bool torpedo);
   virtual bool collisionCheck(float leftBoundry,float rightBoundry, float topBoundry, float bottomBoundry,bool hit,bool alive1,float &GameScore);
   virtual bool destroy(bool collision,float &GameScore);
   virtual void update(float _elapsedTimeSinceCreated, int a, int b,bool hit);
   virtual void arc(float _elapsedTimeSinceCreatedBrain, int c, int &d, int e, int f);
   virtual void dive(float _elapsedTimeSinceCreated, int c , int &d, int e, int f);
   virtual float timeCreated();
   virtual float Timer(float _timeCreated);


    Sprite  _sprite;
    bool _isLoaded;

 private:

   Texture _texture;
   std::string _filename;

   bool collision;
   bool offScreen = false;
   bool diveoffScreen = false;

   float topBoundry;
   float bottomBoundry;
   float leftBoundry;
   float rightBoundry;
   float _timeCreated;
   float LinearVelocityX(float angle);
   float LinearVelocityY(float angle);

 };
#endif
